#ifndef CLICKABLESLIDER_H
#define CLICKABLESLIDER_H

#include <QSlider>
#include <QEvent>
#include <QMouseEvent>
#include <QDebug>

class ClickableSlider : public QSlider
{
    Q_OBJECT
public:
    ClickableSlider(QWidget *parent = nullptr);

protected:
  void mousePressEvent ( QMouseEvent * event )
  {
    if (event->button() == Qt::RightButton)
    {
        if (this->isEnabled()) {
            qDebug() << "disabling slider";
            this->setDisabled(true);
        }
        event->accept();
    }
    QSlider::mousePressEvent(event);
  }
};

#endif // CLICKABLESLIDER_H
