#include <cmath>
#include <QWidget>
#include <QVBoxLayout>
#include "dialgroup.h"

DialGroup::DialGroup(QString name,
                         int min,
                         int max,
                         int decimals,
                         QWidget *parent)
    : QWidget(parent)
{
    QVBoxLayout *layout = new QVBoxLayout;
    layout->setAlignment(Qt::AlignHCenter);
    layout->setContentsMargins(0, 0, 0, 0);
    slider.setFocusPolicy(Qt::NoFocus);
    slider.setRange(min, max);
    slider.setValue(min + max / 2);
    slider.setToolTip(name);
    slider.setContentsMargins(0, 0, 0, 0);
/*
    slider.setMinimumHeight(0);
    slider.setSingleStep(1);
    slider.setMinimumWidth(50);
    slider.setStyleSheet("QDial {"
                "border: 1px solid #aa8895;"
                "background: #20182d;"
                "margin: 0px;}"
                "QSlider::groove:vertical {"
                "border: 1px solid #999999;"
                "width: 25px;}"
                "QDial::tickmarks:vertical {"
                         "background-color: black;"
                         "background: red;"
                         "color: white;}"
*/
    valueBox.setFocusPolicy(Qt::NoFocus);
    valueBox.setButtonSymbols(QAbstractSpinBox::NoButtons);
    valueBox.setMinimumWidth(50);
    valueBox.setRange(min, max);
    valueBox.setValue(0);
    valueBox.setDecimals(decimals);
    valueBox.setObjectName(name);
    valueBox.setToolTip(name);
    valueBox.setAlignment(Qt::AlignHCenter);
    valueBox.setContentsMargins(0, 0, 0, 0);
    layout->addWidget(&slider);
    layout->addWidget(&valueBox);
/*    this->setStyleSheet("border: 1px solid #998090;"
                "background-color: black;"
                "margin: 1px;"
                );*/
    layout->setSpacing(0);
    layout->setContentsMargins(0, 0, 0, 0);
    this->setLayout(layout);
	slider.setObjectName(name);
}

void DialGroup::setValue(float value)
{
    slider.blockSignals(true);
    valueBox.blockSignals(true);
    slider.setValue(value);
    valueBox.setValue(value);
    slider.blockSignals(false);
    valueBox.blockSignals(false);
}
